#!/usr/bin/env perl

@sudokuinit=(
             [0,0,0,0,0,0,0,0,0],
             [0,0,0,0,0,0,0,0,0],
             [0,0,0,0,0,0,0,0,0],
             [0,0,0,0,0,0,0,0,0],
             [0,0,0,0,0,0,0,0,0],
             [0,0,0,0,0,0,0,0,0],
             [0,0,0,0,0,0,0,0,0],
             [0,0,0,0,0,0,0,0,0],
             [0,0,0,0,0,0,0,0,0]
            );

while (<>)
{
  if ( /^{(.*)}$/ )
  {
    $r_sol = parse_model($1);
    print_solution($r_sol);
  }
}

sub parse_model($ )
{
  my @p=split(/ /,$_[0]);
  my @sol=@sudokuinit;
  foreach $atom (@p)
  { 
    if ( $atom =~ /assigned\(([0-9]+),([0-9]+),([0-9]+)\)/ )
    {
      $sol[$1-1][$2-1]=$3;
    }
  }
  return \@sol;
}

sub print_solution
{
  my ($r_sol) = @_;
  $i=0;
  print "+-------+-------+-------+\n";
  foreach $row (@$r_sol)
  {
    $i++;
    $j=0;
    print "| ";
    foreach $el (@$row)
    {
      $j++;
      print "$el ";
      print "| " if $j % 3 == 0;
    }
    print "\n";
    print "+-------+-------+-------+\n" if $i % 3 == 0;
  }
  return;
}

